package com.annimon.ownlang;

import com.annimon.ownlang.parser.SourceLoader;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;
import javax.microedition.io.file.FileSystemRegistry;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.List;

/**
 *
 * @author aNNiMON
 */
public class FileBrowser extends List implements CommandListener {
    
    private static final Command CMD_BACK = new Command("Назад", Command.SCREEN, 1);
    private static final Command CMD_CANCEL = new Command("Отмена", Command.CANCEL, 2);

    /** Текущая активная папка */
    private String currDirName;
    
    private FileConnection fc;
    private Enumeration en;
    
    public FileBrowser() {
        super("Открыть файл", List.IMPLICIT);
        addCommand(CMD_BACK);
        addCommand(CMD_CANCEL);
        setCommandListener(FileBrowser.this);
        currDirName = "/";
    }
    
    public void update() {
        try {
            deleteAll();
            if ("/".equals(currDirName)) {
                en = FileSystemRegistry.listRoots();
            } else {
                final String s = "file:///" + currDirName;
                fc = (FileConnection) Connector.open(s, Connector.READ);
                en = fc.list();
                append("..", null);
            }
            setTitle(currDirName);
            String[] files = getFiles(en);
            for (int i = 0; i < files.length; i++) {
                append(files[i], null);
            }
            if (fc != null) {
                fc.close();
            }
        } catch (IOException ioexception) { }
    }
    
    private void traverseDirectory(String s) {
        if (currDirName.equals("/")) {
            currDirName = s;
        } else if (s.equals("..")) {
            back();
        } else if (s.endsWith("/")) {
            currDirName = currDirName + s;
        } else {
            try {
                // Открываем файл
                Main.showInterpreter(SourceLoader.readSource("file://" + currDirName + s));
            } catch (IOException ex) {
                Console.error("Невозможно открыть файл " + s);
                Main.showInterpreter();
            }
        }
        update();
    }

    private void back() {
        final int i = currDirName.lastIndexOf('/', currDirName.length() - 2);
        if (i != -1) {
            currDirName = currDirName.substring(0, i + 1);
        } else {
            currDirName = "/";
        }
        update();
    }

    private String[] getFiles(Enumeration en) {
        Vector vector = new Vector();
        while (en.hasMoreElements()) {
            vector.addElement((String) en.nextElement());
        }
        final int length = vector.size();
        String s[] = new String[length];
        int i = 0;
        for (int j = 0; j < length; j++) {
            if (((String) vector.elementAt(j)).indexOf("/") != -1) {
                s[i] = ((String) vector.elementAt(j));
                i++;
            }
        }
        for (int k = 0; k < length; k++) {
            if (((String) vector.elementAt(k)).indexOf("/") == -1) {
                s[i] = ((String) vector.elementAt(k));
                i++;
            }
        }
        return s;
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command == List.SELECT_COMMAND) {
            traverseDirectory(getString(getSelectedIndex()));
        } else if (command.equals(CMD_BACK)) {
            back();
        } else if (command.equals(CMD_CANCEL)) {
            Main.showInterpreter();
        }
    }
}
