package com.annimon.ownlang.lib;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Stack;

/**
 *
 * @author aNNiMON
 */
public final class Variables {

    private static final Stack/*<Map<String, Value>>*/ stack;
    private static Hashtable/*<String, Value>*/ variables;
    
    static {
        stack = new Stack/*<>*/();
        variables = new Hashtable/*<>*/();
        Variables.clear();
    }
    
    public static void clear() {
        stack.empty();
        variables.clear();
        variables.put("true", NumberValue.ONE);
        variables.put("false", NumberValue.ZERO);
    }
    
    public static void push() {
        final Hashtable copy = new Hashtable(variables.size());
        for(Enumeration en = variables.keys(); en.hasMoreElements(); ) {
            final Object key = en.nextElement();
            copy.put(key, variables.get(key));
        }
        stack.push(copy);
    }
    
    public static void pop() {
        variables = (Hashtable) stack.pop();
    }
    
    public static boolean isExists(String key) {
        return variables.containsKey(key);
    }
    
    public static Value get(String key) {
        if (!isExists(key)) return NumberValue.ZERO;
        return (Value) variables.get(key);
    }
    
    public static void set(String key, Value value) {
        variables.put(key, value);
    }
    
    public static void remove(String key) {
        variables.remove(key);
    }
}
