package com.annimon.ownlang.lib.modules.functions;

import com.annimon.ownlang.exceptions.ArgumentsMismatchException;
import com.annimon.ownlang.exceptions.TypeException;
import com.annimon.ownlang.lib.*;
import com.annimon.stream.Entry;
import java.util.Enumeration;

public final class functional_foreach implements Function {

    /*@Override*/
    public Value execute(Value[] args) {
        if (args.length != 2) throw new ArgumentsMismatchException("Two args expected");
        
        if (args[1].type() != Types.FUNCTION) {
            throw new TypeException("Function expected in second arg");
        }
        final Value container = args[0];
        final Function consumer = ((FunctionValue) args[1]).getValue();
        if (container.type() == Types.ARRAY) {
            final ArrayValue array = (ArrayValue) container;
            for (Enumeration en = array.iterator(); en.hasMoreElements();) {
                final Value element = (Value) en.nextElement();
                consumer.execute(new Value[]{element});
            }
            return NumberValue.ZERO;
        }
        if (container.type() == Types.MAP) {
            final MapValue map = (MapValue) container;
            for (Enumeration en = map.iterator(); en.hasMoreElements();) {
                final Entry element = (Entry) en.nextElement();
                consumer.execute(new Value[]{(Value)element.getKey(), (Value)element.getValue()});
            }
            return NumberValue.ZERO;
        }
        throw new TypeException("Invalid first argument. Array or map expected");
    }
}