package com.annimon.ownlang.lib.modules.functions;

import com.annimon.ownlang.exceptions.ArgumentsMismatchException;
import com.annimon.ownlang.exceptions.TypeException;
import com.annimon.ownlang.lib.*;
import com.annimon.stream.Entry;
import java.util.Enumeration;

public final class functional_reduce implements Function {

    /*@Override*/
    public Value execute(Value[] args) {
        if (args.length != 3) throw new ArgumentsMismatchException("Three args expected");
        
        if (args[2].type() != Types.FUNCTION) {
            throw new TypeException("Function expected in third arg");
        }
        final Value container = args[0];
        final Value identity = args[1];
        final Function accumulator = ((FunctionValue) args[2]).getValue();
        if (container.type() == Types.ARRAY) {
            Value result = identity;
            final ArrayValue array = (ArrayValue) container;
            for (Enumeration en = array.iterator(); en.hasMoreElements();) {
                final Value element = (Value) en.nextElement();
                result = accumulator.execute(new Value[] {result, element});
            }
            return result;
        }
        if (container.type() == Types.MAP) {
            Value result = identity;
            final MapValue map = (MapValue) container;
            for (Enumeration en = map.iterator(); en.hasMoreElements();) {
                final Entry element = (Entry) en.nextElement();
                result = accumulator.execute(new Value[]{result, (Value)element.getKey(), (Value)element.getValue()});
            }
            return result;
        }
        throw new TypeException("Invalid first argument. Array or map expected");
    }
}