package com.annimon.ownlang.lib.modules.functions;

import com.annimon.ownlang.exceptions.ArgumentsMismatchException;
import com.annimon.ownlang.exceptions.TypeException;
import com.annimon.ownlang.lib.*;
import com.annimon.stream.Collectors;
import com.annimon.stream.Comparator;
import com.annimon.stream.Stream;
import java.util.Vector;

public final class std_sort implements Function {

    /*@Override*/
    public Value execute(Value[] args) {
        if (args.length < 1) throw new ArgumentsMismatchException("At least one argument expected");
        if (args[0].type() != Types.ARRAY) {
            throw new TypeException("Array expected in first argument");
        }
        final Value[] elements = ((ArrayValue) args[0]).getCopyElements();
        
        switch (args.length) {
            case 1:
//                Arrays.sort(elements);
                break;
            case 2:
                if (args[1].type() != Types.FUNCTION) {
                    throw new TypeException("Function expected in second argument");
                }
                final Function comparator = ((FunctionValue) args[1]).getValue();
                Vector v = (Vector) Stream.of(elements).sorted(new Comparator() {
                    public int compare(Object o1, Object o2) {
                        return comparator.execute(new Value[]{(Value)o1, (Value)o2}).asInt();
                    }
                }).collect(Collectors.toList());
                return new ArrayValue(v);
            default:
                throw new ArgumentsMismatchException("Wrong number of arguments");
        }
        
        return new ArrayValue(elements);
    }
    
}