package com.annimon.ownlang.lib.modules;

import com.annimon.ownlang.lib.*;

/**
 *
 * @author aNNiMON
 */
public final class math implements Module {
    
    /*@Override*/
    public void init() {
        Functions.set("abs", new Function() {
            public Value execute(Value[] args) {
                if (args[0].type() == Types.NUMBER) {
                   final Object r = args[0].raw();
                   if (r instanceof Double) return new NumberValue(Math.abs(((Double)r).doubleValue()));
                   if (r instanceof Float) return new NumberValue(Math.abs(((Float)r).floatValue()));
                   if (r instanceof Long) return new NumberValue(Math.abs(((Long)r).longValue()));
                   return new NumberValue(Math.abs(((Integer)r).intValue()));
                }
                return new NumberValue(Math.abs(args[0].asNumber()));
            }
        });
        Functions.set("ceil", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.ceil(args[0].asNumber()));
            }
        });
        Functions.set("cos", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.cos(args[0].asNumber()));
            }
        });
        Functions.set("floor", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.floor(args[0].asNumber()));
            }
        });
        Functions.set("max", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.max(args[0].asNumber(), args[1].asNumber()));
            }
        });
        Functions.set("min", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.min(args[0].asNumber(), args[1].asNumber()));
            }
        });
        Functions.set("sin", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.sin(args[0].asNumber()));
            }
        });
        Functions.set("sqrt", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.sqrt(args[0].asNumber()));
            }
        });
        Functions.set("tan", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.tan(args[0].asNumber()));
            }
        });
        Functions.set("toDegrees", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.toDegrees(args[0].asNumber()));
            }
        });
        Functions.set("toRadians", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(Math.toRadians(args[0].asNumber()));
            }
        });

        Variables.set("PI", new NumberValue(Math.PI));
        Variables.set("E", new NumberValue(Math.E));
    }
}
