package com.annimon.ownlang.lib.modules;

import com.annimon.ownlang.lib.*;

/**
 *
 * @author aNNiMON
 */
public final class types implements Module {

    /*@Override*/
    public void init() {
        Variables.set("OBJECT", new NumberValue(Types.OBJECT));
        Variables.set("NUMBER", new NumberValue(Types.NUMBER));
        Variables.set("STRING", new NumberValue(Types.STRING));
        Variables.set("ARRAY", new NumberValue(Types.ARRAY));
        Variables.set("MAP", new NumberValue(Types.MAP));
        Variables.set("FUNCTION", new NumberValue(Types.FUNCTION));
        
        Functions.set("typeof", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(args[0].type());
            }
        });
        Functions.set("string", new Function() {
            public Value execute(Value[] args) {
                return new StringValue(args[0].asString());
            }
        });
        Functions.set("number", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(args[0].asNumber());
            }
        });
        
        Functions.set("byte", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue((byte)args[0].asInt());
            }
        });
        Functions.set("short", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue((short)args[0].asInt());
            }
        });
        Functions.set("int", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(args[0].asInt());
            }
        });
        Functions.set("long", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue((long)args[0].asNumber());
            }
        });
        Functions.set("float", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue((float)args[0].asNumber());
            }
        });
        Functions.set("double", new Function() {
            public Value execute(Value[] args) {
                return new NumberValue(args[0].asNumber());
            }
        });
    }
}
