package com.annimon.ownlang.parser;

import com.annimon.stream.Iterable;
import java.util.Enumeration;
import java.util.Vector;

public final class ParseErrors implements Iterable/*<ParseError>*/ {

    private final Vector/*<ParseError>*/ errors;

    public ParseErrors() {
        errors = new Vector/*<>*/();
    }
    
    public void clear() {
        errors.removeAllElements();
    }
    
    public void add(Exception ex, int line) {
        errors.addElement(new ParseError(line, ex));
    }
    
    public boolean hasErrors() {
        return !errors.isEmpty();
    }

    /*@Override*/
    public Enumeration/*<ParseError>*/ iterator() {
        return errors.elements();
    }

    /*@Override*/
    public String toString() {
        final StringBuffer result = new StringBuffer();
        for (Enumeration en = errors.elements(); en.hasMoreElements();) {
            result.append((ParseError) en.nextElement()).append('\n');
        }
        return result.toString();
    }
}
