package com.annimon.ownlang.parser;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import javax.microedition.io.Connector;

public final class SourceLoader {

    public static String read(String name) {
        try {
            return readSource(name);
        } catch (IOException ioe) {
            return "";
        }
    }
    public static String readSource(String name) throws IOException {
        // Open file
        if (name.startsWith("file://")) {
            return readStream(Connector.openInputStream(name));
        }
        
        // Open resource
        return readStream(SourceLoader.class.getResourceAsStream(name));
    }
    
    private static String readStream(InputStream is) throws IOException {
        final StringBuffer sb = new StringBuffer();
        final InputStreamReader reader = new InputStreamReader(is, "UTF-8");
        int ch;
        while ( (ch = reader.read()) != -1 ) {
            sb.append((char)ch);
        }
        reader.close();
        return sb.toString();
    }
}
