package com.annimon.ownlang.parser.ast;

import com.annimon.stream.Iterable;
import java.util.Enumeration;
import java.util.Vector;

public final class Arguments implements Iterable/*<Argument>*/ {
    
    private final Vector/*<Argument>*/ arguments;
    private int requiredArgumentsCount;

    public Arguments() {
        arguments = new Vector/*<>*/();
        requiredArgumentsCount = 0;
    }
    
    public void addRequired(String name) {
        arguments.addElement(new Argument(name));
        requiredArgumentsCount++;
    }
    
    public void addOptional(String name, Expression expr) {
        arguments.addElement(new Argument(name, expr));
    }

    public Argument get(int index) {
        return (Argument) arguments.elementAt(index);
    }
    
    public int getRequiredArgumentsCount() {
        return requiredArgumentsCount;
    }

    public int size() {
        return arguments.size();
    }

    /*@Override*/
    public Enumeration/*<Argument>*/ iterator() {
        return arguments.elements();
    }

    /*@Override*/
    public String toString() {
        final StringBuffer result = new StringBuffer();
        result.append('(');
        for (Enumeration en = arguments.elements(); en.hasMoreElements();) {
            Argument arg = (Argument) en.nextElement();
            result.append(arg).append(", ");
        }
        result.append(')');
        return result.toString();
    }
}
