package com.annimon.ownlang.parser.ast;

import com.annimon.ownlang.lib.MapValue;
import com.annimon.ownlang.lib.Value;
import java.util.Enumeration;
import java.util.Hashtable;

/**
 *
 * @author aNNiMON
 */
public final class MapExpression implements Expression {
    
    public final Hashtable/*<Expression, Expression>*/ elements;

    public MapExpression(Hashtable/*<Expression, Expression>*/ arguments) {
        this.elements = arguments;
    }
    
    /*@Override*/
    public Value eval() {
        final int size = elements.size();
        final MapValue map = new MapValue(size);
        for (Enumeration en = elements.keys(); en.hasMoreElements();) {
            final Expression key = (Expression) en.nextElement();
            map.set(key.eval(), ((Expression)elements.get(key)).eval());
        }
        return map;
    }
    
    /*@Override*/
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }

    /*@Override*/
    public String toString() {
        return elements.toString();
    }
}
